package addbk.awtAddressBook;

//EditButtonPanel

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;


public class EditButtonPanel
        extends Panel
        implements ActionListener {

    RevertButton revertButton
            = new RevertButton();

    Button addButton
            = new AddButton();

    Button deleteButton
            = new DeleteButton();

    public void
            actionPerformed(ActionEvent e) {
        ((Runnable)
                e.getSource()).run();
    }


    EditButtonPanel() {
        setLayout(
                new GridLayout(0, 1));
        add(revertButton);
        add(addButton);
        add(deleteButton);
        revertButton.addActionListener(this);
        addButton.addActionListener(this);
        deleteButton.addActionListener(this);
    }

    public class RevertButton extends Button
            implements Runnable {
        RevertButton() {
            super("Revert Record");
        }

        public void run() {
            System.out.println("Run revert");

            AddressBookMediator display =
                    new AddressBookMediator();
            if (display.isEditFlag())
                display.revertRecord();
        }
    }

    public class AddButton extends Button
            implements Runnable {
        AddButton() {
            super("Add Record");
        }

        public void run() {
            System.out.println("Run Add");

            AddressBookMediator display =
                    new AddressBookMediator();
            if (display.isEditFlag())
                display.saveCurrentRecord();

            AddressBookRecord abr =
                    new AddressBookRecord();
            abr.name = "new record";
            AddressBookMediator.setTextFieldValues(abr);
            display.addRecord();
        }
    }

    public class DeleteButton extends Button
            implements Runnable {
        DeleteButton() {
            super("Delete Record");
        }

        public void run() {
            System.out.println("Run Delete");
            AddressBookMediator display =
                    new AddressBookMediator();
            display.deleteCurrentRecord();
        }
    }

} // end class EditButtonPanel
