package addbk.midtermAddressBook;

import futils.Futil;
import addbk.midtermAddressBook.Global;
import java.io.*;

public class CSVWriter {
  static boolean isSwing = false;



  public CSVWriter(AddressBookCollection abd) {

    try {
      BufferedWriter bw = getWriter(
          "select a CSV file for export");
      for (int i = 0; i < (abd.getNumRecords()); i++) {
        AddressRecord ar = abd.readRecord(i);

        // Before writing to the CSV file, erase newline and comma occurences.
        bw.write(Global.addEscChars(ar.getFirstName()) + Global.COMMA);
        bw.write(Global.addEscChars(ar.getLastName()) + Global.COMMA);
        bw.write(Global.addEscChars(ar.getAddress1()) + Global.COMMA);
        bw.write(Global.addEscChars(ar.getAddress2()) + Global.COMMA);
        bw.write(Global.addEscChars(ar.getPhone1()) + Global.COMMA);
        bw.write(Global.addEscChars(ar.getPhone2()) + Global.COMMA);
        bw.write(Global.addEscChars(ar.getPhone3()) + Global.COMMA);
        bw.newLine();
      } // end for
      bw.close();
    }
    catch (FileNotFoundException e) {
    }
    catch (IOException e) {
    }

  } // end constructor

  public static BufferedWriter getWriter(
      String prompt) throws FileNotFoundException,
      IOException {
    return new BufferedWriter(
        new OutputStreamWriter(
        new FileOutputStream(
        Futil.getWriteFile(prompt))));
  }

} // end CSVExport
