package net.web;

import gui.dialogs.ProgressDialog;

import java.io.*;
import java.net.URL;
import java.util.Vector;

public class UrlUtils {
    public static void printVector(Vector v) {
        for (int i = 0; i < v.size(); i++) {
            System.out.println(v.elementAt(i));
        }
    }

    public static Vector lookForJobs(String keyword) {
        return
                getUrl
                //("http://jobsearch.monster.com/jobsearch.asp?q="+keyword);
                (
                        "http://trading.etrade.com/cgi-bin/gx.cgi/Applogic+IPOCurrent");
    }

    public static void main(String args[]) {
        net.proxy.Proxy.setSoeProxy();
        printVector(lookForJobs("java"));
    }

    public static String[] getUrlString(String urlString) {
        Vector v = getUrl(urlString);
        String s[] = new String[v.size()];
        v.copyInto(s);
        return s;
    }

    /**
     * Read a url and put it into a file. This is very good when dealing
     * with large files.
     *
     * @param url input file (like data.jar)
     * @param f   locally created output file.
     */
    public static void getUrl(URL url, File f)
            throws IOException {

        FileOutputStream fos = new FileOutputStream(f);
        BufferedInputStream bis = new
                BufferedInputStream(url.openStream());
        int numberOfBytesRead = 0;
        int buffSize = 65536;
        byte b[] = new byte[buffSize];
        ProgressDialog pd = new ProgressDialog();
        pd.setSize(200, 80);
        pd.setMinimum(0);
        pd.setMaximum(bis.available());
        pd.setUnits(" bytes transferred");
        int amountTransferred = 0;
        pd.setVisible(true);
        while ((numberOfBytesRead = bis.read(b)) != -1) {
            fos.write(b, 0, numberOfBytesRead);
            pd.setAmountDone(amountTransferred);
            amountTransferred = amountTransferred + numberOfBytesRead;
        }
        bis.close();
        fos.close();
        pd.setVisible(false);
    }

    /**
     * Read in entire url at once, into an array of bytes, and return.
     *
     * @param url
     * @return
     */
    public static byte[] getUrlBytes(URL url) {
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        BufferedInputStream bis = null;
        byte b[] = new byte[4096];
        int numberOfBytesRead = 0;
        try {
            bis = new
                    BufferedInputStream(url.openStream());

            while ((numberOfBytesRead = bis.read(b)) != -1) {
                baos.write(b, 0, numberOfBytesRead);
            }

        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            try {
                if (bis != null) bis.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        return baos.toByteArray();
    }

    public static Vector getUrl(String _URLString) {
        Vector contents = new Vector();
        BufferedReader in = null;
        try {
            URL URLString = new URL(_URLString);
            in = new BufferedReader(new
                    InputStreamReader(URLString.openStream()));

            String line;
            while (null != (line = in.readLine()))
                contents.addElement(line);

        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            try {
                if (in != null) in.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        return contents;
    }
}